#include <bits/stdc++.h>
using namespace std;

#define ALL(c) (c).begin(),(c).end()
#define PB push_back
#define IN(x,c) (find(c.begin(),c.end(),x) != (c).end())
#define REP(i,n) for (int i=0;i<(int)(n);i++)
#define FOR(i,a,b) for (int i=(a);i<=(b);i++)
#define INIT(a,v) memset(a,v,sizeof(a))
template<class A, class B> A cvt(B x) { stringstream ss; ss<<x; A y; ss>>y; return y; }

#define SPC << " " <<
#define DEBUG(x) { cerr << #x << " = "; cerr << x << endl; }
#define DEBUG_ITER(x) { cerr << #x << " = ["; for (auto _ : x) cerr << _ << "| "; cerr << "]" << endl; }
template<class A, class B> ostream& operator<<(ostream& os, pair<A,B> &p) {
	os << "(" << p.first << ", " << p.second << ")";
	return os;
}

typedef long long int64;
typedef pair<int,int> PII;
typedef pair<int64,int64> PLL;
typedef vector<int> VI;
typedef vector<PII> VII;
typedef array<int,3> III;
typedef vector<string> VS;

int n,m;
vector<int> adj[1000];
vector<int> fwd[1000],bwd[1000];
int vis[1000];
int deg[1000];

void dfs(int x) {
	cout << x << endl;
	vis[x]=1;
	for (int y : adj[x]) {
		if (!vis[y]) dfs(y);
	}
}

vector<int> dtopo;
void dfs_topo(int x) {
	vis[x]=1;
	for (int y : adj[x]) {
		if (!vis[y]) dfs_topo(y);
	}
	dtopo.push_back(x);
}

int lev[1000], low[1000];

void bridge(int x, int par=-1) {
	vis[x]=1;
	lev[x]=(par==-1)?1:lev[par]+1;
	low[x]=lev[x];
	for (int y : adj[x]) if (y!=par) {
		if (!vis[y]) {  // tree-edge
			bridge(y, x);
			if (low[y]==lev[y]) {  // bridge
				cout << x << " " << y << endl;
			}
			low[x] = min(low[x], low[y]);
		} else {  // back-edge
			low[x] = min(low[x], lev[y]);
		}
	}
}

void cut(int x, int par=-1) {
	vis[x]=1;
	lev[x]=(par==-1)?1:lev[par]+1;
	low[x]=lev[x];
	int c=0,ys=0;
	for (int y : adj[x]) if (y!=par) {
		if (!vis[y]) {  // tree-edge
			ys++;
			cut(y, x);
			if (low[y] >= lev[x]) c=1;
			low[x] = min(low[x], low[y]);
		} else {  // back-edge
			low[x] = min(low[x], lev[y]);
		}
	}
	if (par==-1) {  // root
		if (ys>1) printf("%d\n",x);
	} else {
		if (c) printf("%d\n",x);
	}
}

stack<int> ord;
void dfs1(int x) {
	vis[x]=1;
	for (int y : fwd[x]) {
		if (!vis[y]) dfs1(y);
	}
	ord.push(x);
}

void dfs2(int x) {
	vis[x]=2;
	cout << x << " ";
	for (int y : bwd[x]) {
		if (vis[y]!=2) dfs2(y);
	}
}


int main() {
	/*
	freopen("graf.in","r",stdin);
	cin >> n >> m;
	for (int i=0;i<m;i++) {
		int a,b;
		cin >> a >> b;
		adj[a].push_back(b);
		adj[b].push_back(a);
	}
	dfs(1);
	*/
	/*
	freopen("graf2.in","r",stdin);
	cin >> n >> m;
	for (int i=0;i<m;i++) {
		int a,b;
		cin >> a >> b;
		adj[a].push_back(b);
		deg[b]++;
	}
	queue<int> q;
	for (int i=1;i<=n;i++) {
		if (deg[i]==0) q.push(i);
	}
	vector<int> topo;
	while (!q.empty()) {
		int x=q.front(); q.pop();
		topo.push_back(x);
		for (int y : adj[x]) {
			deg[y]--;
			if (deg[y]==0) q.push(y);
		}
	}
	for (int x : topo) cout << x << " ";
	cout << endl;
	*/
	/*
	// topo via dfs
	for (int x=1;x<=n;x++) {
		if (deg[x]==0) dfs_topo(x);
	}
	reverse(dtopo.begin(),dtopo.end());
	for (int x : dtopo) cout << x << " ";
	*/
	/*
	freopen("graf.in","r",stdin);
	cin >> n >> m;
	for (int i=0;i<m;i++) {
		int a,b;
		cin >> a >> b;
		adj[a].push_back(b);
		adj[b].push_back(a);
	}
	//bridge(1);
	cut(1);
	*/
	// Kosaraju
	freopen("graf3.in","r",stdin);
	cin >> n >> m;
	for (int i=0;i<m;i++) {
		int a,b;
		cin >> a >> b;
		fwd[a].push_back(b);
		bwd[b].push_back(a);
	}
	for (int i=1;i<=n;i++) if (!vis[i]) {
		dfs1(i);
	}
	while (!ord.empty()) {
		int x=ord.top(); ord.pop();
		if (vis[x]!=2) {
			dfs2(x);
			cout << endl;
		}
	}
	return 0;
}
